
#include "vpostproc/pp_qscale.hh"
#include "video12/constants.hh"

#include <iostream.h>


void VideoPostprocessor_QScale::Render(DecodedImageData* dimg)
{
  Assert(dimg->m_picdata1);
  Assert(dimg->m_picdata1->m_codedimage.IsInitialized());

  int blkheight;
  if (dimg->m_picdata1->m_picture_structure == PICSTRUCT_FramePicture)
    blkheight=16;
  else
    blkheight=32;

  const Array2<Macroblock>& mbs = dimg->m_picdata1->m_codedimage;
  Pixel*const* yptr = dimg->m_image.AskFrameY();

  for (int y=0;y<mbs.AskHeight();y++)
    for (int x=0;x<mbs.AskWidth();x++)
      {
	int q=mbs.Ask_const(y,x).m_quantiser_scale_code;
	if (q>blkheight) q=blkheight;

	for (int i=1;i<=q;i++)
	  { yptr[(y+1)*blkheight-i][x*16+15] = 255; }
      }
}
